<?php

/**
 * License
 *
 * @author    MagneticOne
 *
 * @copyright MagneticOne
 *
 * @license   MagneticOne
 */
class PasswordHash
{
  private static $_itoa64;
  private static $_iterationCountLog2;
  private static $_portableHashes;
  private static $_randomState;

  public static function init($iterationCountLog2, $portableHashes)
  {
    self::$_itoa64 = './0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

    if ($iterationCountLog2 < 4 || $iterationCountLog2 > 31)
      $iterationCountLog2 = 8;
    self::$_iterationCountLog2 = $iterationCountLog2;

    self::$_portableHashes = $portableHashes;

    self::$_randomState = microtime();
    if (function_exists('getmypid'))
      self::$_randomState .= getmypid();

    return new self;
  }

  private static function encode64($input, $count)
  {
    $output = '';
    $i = 0;
    do {
      $value = ord($input[$i++]);
      $output .= self::$_itoa64[$value & 0x3f];
      if ($i < $count)
        $value |= ord($input[$i]) << 8;
      $output .= self::$_itoa64[($value >> 6) & 0x3f];
      if ($i++ >= $count)
        break;
      if ($i < $count)
        $value |= ord($input[$i]) << 16;
      $output .= self::$_itoa64[($value >> 12) & 0x3f];
      if ($i++ >= $count)
        break;
      $output .= self::$_itoa64[($value >> 18) & 0x3f];
    } while ($i < $count);

    return $output;
  }

  private static function crypt_private($password, $setting)
  {
    $output = '*0';
    if (substr($setting, 0, 2) == $output)
      $output = '*1';

    $id = substr($setting, 0, 3);

    if ($id != '$P$' && $id != '$H$')
      return $output;

    $countLog2 = strpos(self::$_itoa64, $setting[3]);
    if ($countLog2 < 7 || $countLog2 > 30)
      return $output;

    $count = 1 << $countLog2;

    $salt = substr($setting, 4, 8);
    if (strlen($salt) != 8)
      return $output;

    if (PHP_VERSION >= '5') {
      $hash = md5($salt . $password, TRUE);
      do {
        $hash = md5($hash . $password, TRUE);
      } while (--$count);
    } else {
      $hash = pack('H*', md5($salt . $password));
      do {
        $hash = pack('H*', md5($hash . $password));
      } while (--$count);
    }

    $output = substr($setting, 0, 12);
    $output .= self::encode64($hash, 16);

    return $output;
  }

  public static function CheckPassword($password, $stored_hash)
  {
    $hash = self::crypt_private($password, $stored_hash);
    if ($hash[0] == '*')
      $hash = crypt($password, $stored_hash);

    return $hash == $stored_hash;
  }
}